#Использовать lambdas
#Использовать "../internal"

#Область ПрограммныйИнтерфейс

// Выполняет асинхронно переданную лямбду
//
// Параметры:
//  Алгоритм  - Строка - Лямбда выражение которое требуется исполнить
//  Объект    - Сценарий - Объект который необходимо захватить в лямбду
//  Параметры - Массив из Произвольный - Параметры алгоритма
//
// Возвращаемое значение:
//  Обещание - Обещание о выполнении переданного алгоритма
//
Функция ВыполнитьЛямбду(Знач Алгоритм, Объект, Параметры) Экспорт

	Алгоритм = Лямбда.Выражение(Алгоритм)
		.ЗахватитьОбъект(Объект)
		.ВДействие();

	Результат = Новый Обещание(Алгоритм, Параметры);

	ОбещанияСлужебный.ЗапуститьВыполнениеОбещания(Результат);

	Возврат Результат;

КонецФункции

// Выполняет асинхронно переданный делегат
//
// Параметры:
//  Действие  - Действие - Делегат на метод который требуется исполнить
//  Параметры - Массив из Произвольный - Параметры метода
//
// Возвращаемое значение:
//  Обещание - Обещание о выполнении переданного метода
//
Функция ВыполнитьДелегат(Действие, Параметры) Экспорт

	Результат = Новый Обещание(Действие, Параметры);

	ОбещанияСлужебный.ЗапуститьВыполнениеОбещания(Результат);

	Возврат Результат;

КонецФункции

// Ожидает исполнение всех переданных обещаний
//
// Параметры:
//  Обещания - Массив из Обещание - Обещания которых ожидаем
//  Таймаут -  Число- Количество миллисекунд по истечении которых будет выброшено исключение
//
Процедура ОжидатьВсе(Обещания, Таймаут = 0) Экспорт
	ОбещанияСлужебный.ОжидатьВсе(Обещания, Таймаут);
КонецПроцедуры

#КонецОбласти
